int xPos; //Position des Balles
int speed=2; //Wie schnell bewegt es sich
int xDir=1; //Direktion des Balles
int score=0; //Anfangspunktzahl
int lives=7; //Anzahl Leben zu Beginn
boolean gameVerloren=false; //Hast du schon verloren?
boolean gameStarted = false; //Hat das Spiel schon angefangen?
boolean rules = false;
PImage img;
PImage back;
boolean draw_image = false;
int timer = 0;
int img_timer = 0;

void setup() //Wird einmal ausgeführt, wenn Programm beginnt
{
  size (500,400);
  smooth();
  xPos=width/2; //Zentriert den Ball
  fill(0,128,128); //Macht den Text und Ball grün
  textSize(25); //Legt Grösse des Textes fest
  img = loadImage("flame.png");
  back = loadImage("background.jpg");
  frameRate(30);
}

void draw() //Schleifen immer wieder
{
  if (gameStarted) {
    drawGameScreen();
  } else if (rules) {
    rules();
  } else {
    drawStartScreen();
  }
  timer++;
}


void rules() {
  background(0);
  fill(255);
  textSize(15);
  text("Man muss den Kreis anklicken.",  250, 1000);
  text("Er wird immer schneller bei jedem Klick. ", 250, 150);
  text("Wenn der Kreis verfehlt wird, verliert man ein Leben.",250, 200);
  text("Insgesamt hat man 7 Leben ", 250, 250);
  text("Das Ziel ist es so viele Punkte wie möglich zu erzielen.", 250, 300);
}


void drawStartScreen() {
  background(0);
  textSize(50);
  textAlign(CENTER);
  fill(0,128,128);
  text("Burning Circle", width/2, height/2 - 50);
  textSize(30);
  text("Press space to start", width/2, height/2 + 50);
  text("Press R for rules",  width/2, height/2 + 100);
}

void drawGameScreen() {
  //background (0); //Schwarzer Hintergrund
  image(back, 0, 0, 500, 400);
  if (draw_image) {
    image(img, xPos - 50, 150, 100, 100);
    if (timer - img_timer > 90) {
      draw_image = false;
    }
  }
  circle(xPos, height/2,60); //Zeichnet den Ball
  xPos=xPos+(speed*xDir); //Aktualisiert Ballposition
  if (xPos > width-20 || xPos<20) //Hat der Ball die Seite getroffen?
  {
    xDir=-xDir; //Wenn ja, dann wird Seite geändert
  }
  text("score = "+score,80,30); //Punktzahl
  text("lives = "+lives,width-70,30); //verbleibende Leben
  if (lives<=0) //überprüfen sie, ob sie verloren haben
  {
    textSize(29);
    fill(255, 0, 0);
    text("Game over. Press space to try again", 250,200);
    noLoop(); //Beendet Schleifen am Ende der Draw-Funktion
    gameVerloren=true;
    textSize(13);
  }
 
}

void keyPressed() {
  if (key == ' ') {
    if (!gameStarted) {
      gameStarted = true;
    }
    if (gameVerloren==true) //Wenn Geschwindigkeit grösser ist als 1, dann Geschwindigkeit verringert 
      {
        speed=2; //Setzt alle variablen auf Anfangsbedingungen zurück
        lives=7;
        score=0;
        textSize(25);
        xPos=width/2;
        xDir=1;
        gameVerloren=false;
        timer = 0;
        img_timer = 0;
        draw_image = false;
        gameStarted = false;
        loop(); //Looping Draw Funktion beginnt erneut
     }
  }
  if ((key == 'R' || key == 'r') && !rules) {
      rules = true;
  } else if  ((key == 'R' || key == 'r') && rules) {
     rules = false; 
  }
}

void mousePressed() //läuft, wenn Maus gedrückt wird
{
   if (gameStarted) {
     if (dist(mouseX, mouseY, xPos, 200)<=60) //haben wir das Ziel getroffen?
    {
      score=score+speed; //erhöht die Geschwindigkeit
      speed=speed+1; //Erhöht die Punktzahl
    }
    else //verfehlt
    {
      if (speed<1) //If speed is greater than 1 decrease the speed
      {
      speed=speed-1;
      }
      lives=lives-1; //Take away one life
      draw_image = true;
      img_timer = timer;
    }
    
  }
}
